# Copyright 2014 - 2016 Paul Hänsch
#
# This file is part of Confetti.
# 
# Confetti is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Confetti is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with Confetti.  If not, see <http://www.gnu.org/licenses/>. 

n=$(printf %s "$values[N]" \
    | sed -rn 's:^([^;]*)(\;[^;]*)(\;[^;]*)?(\;[^;]*)?(\;[^;]*)?$:\4 \2 \3 \1 \5:gp' \
    | sed -r 's:,: :;s:\;: :g;s: +: :g;s:^ $::;'
   )
fullname="${n:-${values[FN]:-${values[NICKNAME]}}}"

hi_company="$(printf %s "${values[X-HEALTH-INSURANCE]}" |cut -d\; -f1)"
hi_number="$(printf %s "${values[X-HEALTH-INSURANCE]}" |cut -d\; -f2)"
hi_status="$(printf %s "${values[X-HEALTH-INSURANCE]}" |cut -d\; -f3)"


cat <<END_HTML
  <div class="section basic">
    <h2 class="item FN">$fullname</h2>
    ${values[GENDER]:+<span class="\""item GENDER"\"">$(l10n $values[GENDER])</span>}

    $(for n in NICKNAME NICKNAME{0..10}; do
      echo "${values[$n]:+<span class="\""item NICKNAME"\"">aka. $values[$n]</span>}"
    done)

    ${values[BDAY]:+<span class="\""item BDAY"\""><label>*:</label> ${values[BDAY]}</span>}
    ${values[SOUND]:+<audio controls="controls" class="\""item SOUND"\""><source type="audio/ogg" src="\""data:audio/ogg;base64,$values[SOUND]"\"" /></audio>}
    ${values[PHOTO]:+<img class="\""item PHOTO"\"" src="\""data:image/$values[PHOTO_TYPE];base64,$values[PHOTO]"\"" />}
    ${values[LOGO]:+<img class="\""item LOGO"\"" src="\""data:image/$values[LOGO_TYPE];base64,$values[LOGO]"\"" />}

    <h3>$(l10n ADR)</h3>
    $(for n in ADR ADR{0..10}; do
      echo "${values[$n]:+<span class="\""item ADR"\"">$values[$n]</span>}"
    done)
    ${values[URL]:+<h3>$(l10n URL)</h3>}
    $(for n in URL URL{0..10}; do
      echo "${values[$n]:+<span class="\""item URL"\""><a href="\""$values[$n]"\"">$values[$n]</a></span>}"
    done)
  </div><!--

  --><div class="section phone">
    <h3>$(l10n TEL)</h3>
    $(for n in TEL TEL{0..10}; do
      echo "${values[$n]:+<span class="\""item TEL"\"">$(l10n t${values[${n}_TYPE]}) $values[$n]</span>}"
    done)
    ${values[EMAIL]:+<h3>$(l10n EMAIL)</h3>}
    $(for n in EMAIL EMAIL{0..10}; do
      echo "${values[$n]:+<span class="\""item EMAIL"\""><a href="\""mailto:$values[$n]"\"">$values[$n]</a></span>}"
    done)
    ${values[IMPP]:+<h3>$(l10n IMPP)</h3>}
    $(for n in IMPP IMPP{0..10}; do
      echo "${values[$n]:+<span class="\""item IMPP"\"">$values[${n}_TYPE] <a href="\""$values[$n]"\"">$values[$n]</a></span>}"
    done)
  </div><!--

  --><div class="section insurance">
    <h3>$(l10n X-HEALTH-INSURANCE)</h3>
    ${hi_company:+<span class="\""item hi_comapany"\"">${hi_company}</span>}
    ${hi_number:+<span class="\""item hi_number"\""><label>$(l10n hi_number):</label> ${hi_number}</span>}
    ${hi_status:+<span class="\""item hi_status"\""><label>$(l10n hi_status):</label> ${hi_status}</span>}
  </div><!--

  --><div class="section note">
    ${values[NOTE]:+<h3>$(l10n NOTE)</h3>}
    $(for n in NOTE NOTE{0..10}; do
      echo "${values[$n]:+<span class="\""item NOTE"\"">$values[$n]</span>}"
    done)
    ${values[X-CLIENT-REFERRAL]:+<h3>$(l10n X-CLIENT-REFERRAL)</h3>}
    $(for n in X-CLIENT-REFERRAL X-CLIENT-REFERRAL{0..10}; do
      echo "${values[$n]:+<span class="\""item X-CLIENT-REFERRAL"\"">$values[$n]</span>}"
    done)
  </div><!--

  --><div class="section prescriptions">
    <h3>$(l10n prescriptions)</h3>
    <ul>
    $(declare -A mpx
      find "$_DATA/prescriptions/" -name "${id%.vcf}.*.mpx" \
      | while read pfile; do
        mpx=(); cat "$pfile" |while read -r line; do
          val="${line#*:}"
          mpx[${line%%:*}]="$(htmlsafe "${val//\\n/$BR}")"
        done
        printf '<li><a href="?p=prescriptions&amp;client=%s#%s" >%s: %s - %s</a></li>' \
          "${id}" "${pfile##*/}" "${mpx[date]}" "${mpx[indicator]}" \
          "$([ -n "${mpx[remidy]}" ] && printf '%s %s' "${mpx[quantity]}" "${mpx[remidy]}" 
             for n in {0..10}; do
               [ -n "${mpx[remidy${n}]}" ] && printf ', %s %s' "${mpx[quantity${n}]}" "${mpx[remidy${n}]}" 
             done
           )"
      done |sort -r
    )
    </ul>
  </div>
END_HTML
